package com.yunzhi.nanyang.controller;

import com.github.binarywang.wxpay.bean.notify.*;
import com.github.binarywang.wxpay.exception.WxPayException;
import com.github.binarywang.wxpay.service.WxPayService;
import com.yunzhi.nanyang.common.BaseController;
import com.yunzhi.nanyang.common.WxUtils;
import com.yunzhi.nanyang.service.ITaPayService;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@Api(tags = "微信小程序")
@RestController
@RequestMapping("/wxpay")
public class WxPayController extends BaseController {

    @Autowired
    WxUtils wxUtils;

    @Autowired
    ITaPayService orderPayService;

    @ResponseBody
    @RequestMapping("/notify/{client}/order")
    public String payNotify(@PathVariable String client,
                            @RequestBody String jsonData) {
        WxPayService payService = null;
        if ("ios".equals(client) || "android".equals(client)) {
            payService = wxUtils.getAndroidPayService();
        } else {
            payService = wxUtils.getMiniPayService();
        }

        WxPayOrderNotifyV3Result result = null;
        try {
            result = payService.parseOrderNotifyV3Result(jsonData, null);
            orderPayService.notifyOrder(result.getResult());
            return WxPayNotifyResponse.success("OK");
        } catch (Exception e) {
            e.printStackTrace();
            return WxPayNotifyResponse.fail(e.getMessage());
        }


    }

    @ResponseBody
    @RequestMapping("/notify/{client}/refund")
    public String refundNotify(@PathVariable String client,
                               @RequestBody String jsonData) {
        WxPayService payService = null;
        if ("ios".equals(client) || "android".equals(client)) {
            payService = wxUtils.getAndroidPayService();
        } else {
            payService = wxUtils.getMiniPayService();
        }

        WxPayRefundNotifyV3Result result = null;
        try {
            result = payService.parseRefundNotifyV3Result(jsonData, null);
            orderPayService.refundNotifyOrder(result.getResult());
            return WxPayNotifyResponse.success("OK");
        } catch (Exception e) {
            e.printStackTrace();
            return WxPayNotifyResponse.fail(e.getMessage());
        }

    }

}
